#include <stdlib.h>
#if defined(WIN32)
#  include "glut.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif
#include "menu.h"

static int shape = 0;  /* ɽ */

/*
** ޷ɽ
*/
void showShape(void)
{
  switch (shape) {
  case 0:
    glutSolidTeapot(1.0);
    break;
  case 1:
    glutSolidCube(2.0);
    break;
  case 2:
    glutSolidSphere(1.0, 16, 8);
    break;
  case 3:
    glutSolidTorus(0.5, 1.0, 12, 16);
    break;
  }
}

/*
** ˥塼ȥι ܤƬ c դ)
*/
static void markEntry(int i, char c, char *s)
{
  char buffer[128], *p = buffer;
  int n = sizeof(buffer) / sizeof(char) - 1;

  *p = c;
  do {
    if (--n <= 0) {
      *p = '\0';
      break;
    }
  }
  while ((*++p = *++s) != '\0');

  glutChangeToMenuEntry(i + 1, buffer, i);
}

/*
** ޷Υ˥塼
*/
static char *shapeName[] = {
  "*Teapot",
  " Cube",
  " Sphere",
  " Torus",
};

/*
** ޷˥塼
*/
static void shapeMenu(int m)
{
  markEntry(shape, ' ', shapeName[shape]);
  shape = m;
  markEntry(shape, '*', shapeName[shape]);
  glutPostRedisplay();
}

/*
** ƥΥ˥塼
*/
static char *textureName[] = {
  "*Normal",
  " Spot",
  " Fur",
};

/*
** ƥ˥塼
*/
static void textureMenu(int m)
{
  static GLubyte texture[TEXHEIGHT * TEXWIDTH * 3];

  makeTexture(texture, TEXWIDTH, TEXHEIGHT, m);
  glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, TEXWIDTH, TEXHEIGHT,
      GL_RGB, GL_UNSIGNED_BYTE, texture);
  markEntry(shape, ' ', textureName[shape]);
  markEntry(shape, '*', textureName[shape]);
  glutPostRedisplay();
}

/*
** ᥤ˥塼
*/
static void mainMenu(int m)
{
  switch(m) {
  case 0:
    exit(0);
  default:
    break;
  }
}

/*
** ˥塼
*/
void menu(void)
{
  int i, shapeId, textureId;
  
  shapeId = glutCreateMenu(shapeMenu);
  for (i = 0; i < (sizeof shapeName) / (sizeof (char *)); ++i)
    glutAddMenuEntry(shapeName[i], i);

  textureId = glutCreateMenu(textureMenu);
  for (i = 0; i < (sizeof textureName) / (sizeof (char *)); ++i)
    glutAddMenuEntry(textureName[i], i);

  glutCreateMenu(mainMenu);
  glutAddSubMenu("Shape", shapeId);
  glutAddSubMenu("Texture", textureId);
  glutAddMenuEntry("Quit", 0);

  glutAttachMenu(GLUT_RIGHT_BUTTON);
}
